// Blueprint: auto-generated by ClientPool plugin
package proc3

import (
	"gitlab.mpi-sws.org/cld/blueprint/blueprint-compiler/stdlib"
	"context"
	"strconv"
	"spec/services"
)

type LeafServiceImplClientpool struct {
	pool *stdlib.ClientPool[*LeafServiceImplTracerClient]
}
func NewLeafServiceImplClientpool(max_clients string,fn func()*LeafServiceImplTracerClient) *LeafServiceImplClientpool {
	max_clients_num, _ := strconv.ParseInt(max_clients, 10, 64)
	pool := stdlib.NewClientPool[*LeafServiceImplTracerClient](max_clients_num, fn)
	return &LeafServiceImplClientpool{pool: pool}
	
}

func (cp *LeafServiceImplClientpool) Object(ctx context.Context, obj services.LeafObject) (services.LeafObject, error) {
	client := cp.pool.Pop()
	defer cp.pool.Push(client)
	return client.Object(ctx, obj)
}

func (cp *LeafServiceImplClientpool) Leaf(ctx context.Context, a int64) (int64, error) {
	client := cp.pool.Pop()
	defer cp.pool.Push(client)
	return client.Leaf(ctx, a)
}

